"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Unstable_StatefulDataTable = Unstable_StatefulDataTable;

var React = _interopRequireWildcard(require("react"));

var _index = require("../button/index.js");

var _search = _interopRequireDefault(require("../icon/search.js"));

var _index2 = require("../input/index.js");

var _index3 = require("../styles/index.js");

var _index4 = require("../tag/index.js");

var _constants = require("./constants.js");

var _filterMenu = _interopRequireDefault(require("./filter-menu.js"));

var _dataTable = require("./data-table.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function useDuplicateColumnTitleWarning(columns) {
  React.useEffect(function () {
    var titles = columns.reduce(function (set, column) {
      return set.add(column.title);
    }, new Set());

    if (titles.size < columns.length) {
      console.warn('Columns titles must be unique else will result in non-deterministic filtering.');
    }
  }, [columns]);
}

function useSortParameters() {
  var _React$useState = React.useState(-1),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      sortIndex = _React$useState2[0],
      setSortIndex = _React$useState2[1];

  var _React$useState3 = React.useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      sortDirection = _React$useState4[0],
      setSortDirection = _React$useState4[1];

  function handleSort(columnIndex) {
    if (columnIndex === sortIndex) {
      if (sortDirection === _constants.SORT_DIRECTIONS.ASC) {
        setSortIndex(-1);
        setSortDirection(_constants.SORT_DIRECTIONS.DESC);
      } else {
        setSortDirection(_constants.SORT_DIRECTIONS.ASC);
      }
    } else {
      setSortIndex(columnIndex);
      setSortDirection(_constants.SORT_DIRECTIONS.DESC);
    }
  }

  return [sortIndex, sortDirection, handleSort];
}

function useResizeObserver(ref, callback) {
  React.useLayoutEffect(function () {
    if (typeof document !== 'undefined') {
      if (ref.current) {
        var observer = new ResizeObserver(callback);
        observer.observe(ref.current);
        return function () {
          return observer.disconnect();
        };
      }
    }
  }, [ref]);
}

function QueryInput(props) {
  var _useStyletron = (0, _index3.useStyletron)(),
      _useStyletron2 = _slicedToArray(_useStyletron, 2),
      css = _useStyletron2[0],
      theme = _useStyletron2[1];

  var _React$useState5 = React.useState(''),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      value = _React$useState6[0],
      setValue = _React$useState6[1];

  React.useEffect(function () {
    var timeout = setTimeout(function () {
      return props.onChange(value);
    }, 250);
    return function () {
      return clearTimeout(timeout);
    };
  }, [value]);
  return React.createElement("div", {
    className: css({
      width: '375px'
    })
  }, React.createElement(_index2.Input, {
    "aria-label": "Search by text",
    overrides: {
      Before: function Before() {
        return React.createElement("div", {
          className: css({
            display: 'flex',
            alignItems: 'center',
            paddingLeft: theme.sizing.scale500
          })
        }, React.createElement(_search["default"], {
          size: "18px"
        }));
      }
    },
    size: _index2.SIZE.compact,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    },
    value: value,
    clearable: true
  }));
}

function Unstable_StatefulDataTable(props) {
  var _useStyletron3 = (0, _index3.useStyletron)(),
      _useStyletron4 = _slicedToArray(_useStyletron3, 2),
      css = _useStyletron4[0],
      theme = _useStyletron4[1];

  useDuplicateColumnTitleWarning(props.columns);

  var _useSortParameters = useSortParameters(),
      _useSortParameters2 = _slicedToArray(_useSortParameters, 3),
      sortIndex = _useSortParameters2[0],
      sortDirection = _useSortParameters2[1],
      handleSort = _useSortParameters2[2];

  var _React$useState7 = React.useState(new Map()),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      filters = _React$useState8[0],
      setFilters = _React$useState8[1];

  var _React$useState9 = React.useState(''),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      textQuery = _React$useState10[0],
      setTextQuery = _React$useState10[1];

  function addFilter(filterParams, title) {
    filters.set(title, filterParams);
    setFilters(new Map(filters));
  }

  function removeFilter(title) {
    filters["delete"](title);
    setFilters(new Map(filters));
  }

  var _React$useState11 = React.useState(new Set()),
      _React$useState12 = _slicedToArray(_React$useState11, 2),
      selectedRowIds = _React$useState12[0],
      setSelectedRowIds = _React$useState12[1];

  function handleSelectChange(next) {
    setSelectedRowIds(next);
    var selectionCallback = props.onSelectionChange;

    if (selectionCallback) {
      selectionCallback(props.rows.filter(function (r) {
        return next.has(r.id);
      }));
    }
  }

  function handleSelectMany(incomingRows) {
    // only adds rows that are visible in the table
    handleSelectChange(new Set([].concat(_toConsumableArray(selectedRowIds), _toConsumableArray(incomingRows.map(function (r) {
      return r.id;
    })))));
  }

  function handleSelectNone() {
    handleSelectChange(new Set());
  }

  function handleSelectOne(row) {
    if (selectedRowIds.has(row.id)) {
      selectedRowIds["delete"](row.id);
    } else {
      selectedRowIds.add(row.id);
    }

    handleSelectChange(new Set(selectedRowIds));
  }

  var headlineRef = React.useRef(null);

  var _React$useState13 = React.useState(64),
      _React$useState14 = _slicedToArray(_React$useState13, 2),
      headlineHeight = _React$useState14[0],
      setHeadlineHeight = _React$useState14[1];

  useResizeObserver(headlineRef, function (entries) {
    setHeadlineHeight(entries[0].contentRect.height);
  });
  return React.createElement(React.Fragment, null, React.createElement("div", {
    className: css({
      height: "".concat(headlineHeight, "px")
    })
  }, React.createElement("div", {
    ref: headlineRef
  }, !selectedRowIds.size && React.createElement("div", {
    className: css({
      alignItems: 'end',
      display: 'flex',
      flexWrap: 'wrap',
      paddingTop: theme.sizing.scale500,
      paddingBottom: theme.sizing.scale500
    })
  }, React.createElement(QueryInput, {
    onChange: setTextQuery
  }), Array.from(filters).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        title = _ref2[0],
        filter = _ref2[1];

    return React.createElement(_index4.Tag, {
      key: title,
      onActionClick: function onActionClick() {
        return removeFilter(title);
      },
      overrides: {
        Root: {
          style: {
            borderTopLeftRadius: '36px',
            borderTopRightRadius: '36px',
            borderBottomLeftRadius: '36px',
            borderBottomRightRadius: '36px',
            height: '36px',
            marginTop: null,
            marginBottom: null
          }
        },
        Action: {
          style: {
            borderTopRightRadius: '36px',
            borderBottomRightRadius: '36px',
            height: '22px'
          }
        }
      }
    }, React.createElement("span", {
      className: css(_objectSpread({}, theme.typography.font150, {
        color: theme.colors.mono1000
      }))
    }, title), ": ", filter.description);
  }), React.createElement(_filterMenu["default"], {
    columns: props.columns,
    filters: filters,
    rows: props.rows,
    onSetFilter: addFilter
  })), Boolean(selectedRowIds.size) && props.batchActions && React.createElement("div", {
    style: {
      display: 'flex',
      alignItems: 'center',
      paddingTop: theme.sizing.scale400,
      paddingBottom: theme.sizing.scale400
    }
  }, props.batchActions.map(function (action) {
    function onClick(event) {
      action.onClick({
        clearSelection: handleSelectNone,
        event: event,
        selection: props.rows.filter(function (r) {
          return selectedRowIds.has(r.id);
        })
      });
    }

    if (action.renderIcon) {
      var Icon = action.renderIcon;
      return React.createElement(_index.Button, {
        key: action.label,
        overrides: {
          BaseButton: {
            props: {
              'aria-label': action.label
            }
          }
        },
        onClick: onClick,
        kind: _index.KIND.tertiary,
        shape: _index.SHAPE.round
      }, React.createElement(Icon, {
        size: 16
      }));
    }

    return React.createElement(_index.Button, {
      key: action.label,
      onClick: onClick,
      kind: _index.KIND.secondary,
      size: _index.SIZE.compact
    }, action.label);
  })))), React.createElement("div", {
    style: {
      width: '100%',
      height: "calc(100% - ".concat(headlineHeight, "px)")
    }
  }, React.createElement(_dataTable.Unstable_DataTable, {
    batchActions: props.batchActions,
    columns: props.columns,
    filters: filters,
    onSelectionChange: props.onSelectionChange,
    onSelectMany: handleSelectMany,
    onSelectNone: handleSelectNone,
    onSelectOne: handleSelectOne,
    onSort: handleSort,
    rows: props.rows,
    rowActions: props.rowActions,
    selectedRowIds: selectedRowIds,
    sortDirection: sortDirection,
    sortIndex: sortIndex,
    textQuery: textQuery
  })));
}